;+
; NAME: eis_md_packet_reader__end_exposure_flags.pro
;
; PURPOSE: Has the last packet of an exposure been read?
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

function eis_md_packet_reader::end_exposure_flags
;  msf = *(*(self.md_packet)->md_header)->main_sequence_flag()
;  ssf = *(*(self.md_packet)->md_header)->sub_sequence_flag()
;  msf = *(self.md_packet)->md_header->main_sequence_flag()
;  ssf = *(self.md_packet)->md_header->sub_sequence_flag()
  p = *(self.md_packet)
  h = p->md_header()
  msf = h->main_sequence_flag()
  ssf = h->sub_sequence_flag()
  return, (((msf eq 1) or (msf eq 0)) and (ssf eq 3)) or $
          (((msf eq 1) or (msf eq 0)) and (ssf eq 2))
end
