;+
; NAME: eis_md_packet_reader__read_header.pro
;
; PURPOSE: Definition of the EIS ccsds packet structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/05 mcrw	wrote
;       14/08/06 mcrw	added documentation
;
;-

;+ 
; Read a complete ccsds packet containing the mission data header as it's payload.
; Return only the ccsds packet payload.			
;-

function eis_md_packet_reader::read_header, ccsds_reader
;  print, 'eis_md_packet_reader::read_header:'
  self->trace, 'eis_md_packet_reader::read_header:'
  got_packet = 0
;  m = *(self.md_packet)
;  h = m->md_header()
;  d = h->eis_md_header()
;  help,m,h,d
;;  print, N_Tags(d, /Length)
;;;  h = *(*(*(self.md_packet).md_header).eis_md_packet_header)
;;;help, h
;  foo = *(ccsds_reader)->read_md_header(d)
;  h->set_eis_md_header,d
;  m->set_md_header,h
;  *(self.md_packet)->set_md_header, h
;;  print, 'eis_md_packet_reader::read_header : SID = ' +  strtrim(string(d.datatype, format='(Z)'), 2)

;;;  got_packet = *(ccsds_reader)->next_packet(packet, /payload_only)
  got_packet = *(ccsds_reader)->next_packet(packet)

  if got_packet then begin
;     h = *(self.md_packet)->md_header() ;->ccsds_header() ; = *(ccsds_reader).ccsds_packet->ccsds_header()
;     c = h->ccsds_header()
;     r = *(ccsds_reader)
;     help,r
;     p = r->ccsds_packet()
;     ch = *p->ccsds_header()
;     c = ch
     
     *(self.md_packet)->populate_header, packet
  endif
  return, got_packet
end

