;+
; NAME: eis_md_raster__read.pro
;
; PURPOSE: Definition of the main EIS raster structure
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: None
;
; CALLS: None
;
; COMMON BLOCKS:None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	23/11/18 mcrw	wrote
;
;-

pro eis_md_raster::read, filename, verbose=verbose, rescued=rescued
  print, 'eis_md_raster::read ' + filename
  return
  self.filename = filename
  if keyword_set(rescued) then self.rescued = rescued
  if keyword_set(verbose) then self.verbose = verbose
  self.raster_reader = ptr_new(obj_new('eis_md_raster_reader', rescued=rescued, verbose=self.verbose))
  self.ccsds_reader = ptr_new(obj_new('eis_ccsds_reader','FRED', 'v1.0', 'eis_ccsds_packet'))
;;;	self.exposure_list = ptr_new()
  
;	ccsds_reader = obj_new('eis_ccsds_reader','FRED', 'v1.0')
;	help,ccsds_reader
;	self.ccsds_reader = *ccsds_reader
  
  print
  print, 'eis_md_raster::read Open file for reading'
  print
  if *(self.ccsds_reader)->open_for_reading(filename) then begin
     *(self.raster_reader)->read, self.ccsds_reader
     *(self.ccsds_reader)->close_input
     self.exposure_list = *(self.raster_reader)->exposure_list()
     print
     print, 'eis_md_raster::read Got exposures'
     print
     ;*(self.ccsds_reader)->close_input
  endif else begin
     print, 'eis_md_raster::read Couldnt open file'
     return
  endelse
  
;  print, 'Number of exposures: ', *(self.exposure_list)->count()
  
;;	*(self.raster_reader)->tidy_up
;;	*(self.ccsds_reader)->tidy_up
  obj_destroy, *self.ccsds_reader
;;;;;	obj_destroy, *self.raster_reader ; will this get rid of our exposure_list as well?
  
;  print
;  print
;  print
;;  print, 'Number of exposures: ', *(self.exposure_list)->count()
;;  print
;
;  exposure_list = *(self.exposure_list)
;  num_exposures = exposure_list->count()
;  print, 'Number of exposures: ', num_exposures
;
;  for i = 0, num_exposures - 1 do begin
;     exposure = *(exposure_list[i])
;     help, exposure
;     packet_count = exposure->count()
;     help,packet_count
;     for packet_number = 0, packet_count - 1 do begin
;        packet = *(exposure[packet_number])
;        help,packet
;        packet->debug
;     endfor
;  endfor
  
;;	foo = *(self.exposure_list)->toArray()
;
;  print, 'Getting exposure list'
;  help, self.exposure_list				; <Expression>    POINTER   = <PtrHeapVar19>
;  exposure_list = *(self.exposure_list)			
;  print
;
;  help, exposure_list              ; EXPOSURE_LIST   LIST  <ID=18  NELEMENTS=1>
;  help, exposure_list[0]				; <Expression>    POINTER   = <PtrHeapVar16>
;  help, *exposure_list[0]				; <PtrHeapVar16>  LIST  <ID=15  NELEMENTS=15>
;  help, *(exposure_list[0])				; <PtrHeapVar16>  LIST  <ID=15  NELEMENTS=15>
;  help, (*(self.exposure_list))[0]			; <Expression>    POINTER   = <PtrHeapVar16>
;
;  print, 'Count: ', *(exposure_list[0])->count()
;
;  ee = *(exposure_list[0])
;  print, 'help, *(ee[0])'
;  help, *(ee[0])					; <PtrHeapVar31>  OBJREF    = <ObjHeapVar28(EIS_MD_PACKET)>
;
;  print, 'help, *((*(self.exposure_list))[0])'
;  help, *((*(self.exposure_list))[0])			; <PtrHeapVar16>  LIST  <ID=15  NELEMENTS=15>
;
;  *(ee[0])->debug
;
;  print

;  for i = 0, *(self.exposure_list)->count() - 1 do begin
;     exposure = *(exposure_list[i])
;     exposure_count = *(exposure_list[i])->count()
;     help, exposure             ; FOO             LIST  <ID=15  NELEMENTS=15>
;     help, exposure_count
;     j_end = exposure_count - 1
;     help, j_end
;     for j = 0, j_end do begin
;;        for j = 0, *(self.exposure_list[i])->count() - 1 do begin
;        packet = *(exposure[j])
;        help, packet               ; BAR             OBJREF    = <ObjHeapVar28(EIS_MD_PACKET)>, BAR          ;   OBJREF    = <ObjHeapVar34(EIS_MD_PACKET)> ...
;                                ;*(exposure[j])->debug
;        packet->debug              ; *(ee[0])->debug
;     endfor
;  endfor

; 	l = *(self.packet_list)
;	help, l
;	help, *(l[0])
;	*(l[0])->debug

end
